# urlfilter

[urlfilter] (https://dev.iopsys.eu/iopsys/urlfilter)

## Introduction

urlfilter blocks list of urls for the list of mac addresses passed to it. *urlfilter* uses the libnetfilter-queue along with libnetlink.
APIs to achieve the requirement.

## Project Components

Project consists of following components:

- Application itself written in C programming language

## Build Instructions

`urlfilter` is written using C programming language and depends on a number of components found in `OpenWrt` for building and running.
 - libnetfilter-queue
 - libnfnetlink
 - iptables-mod-nfqueue

## Pre-requisites

Before running the application you need to add a rule in the iptables to forward the http, https and dns query/response packets to NFQUEUE.
NFQUEUE is an iptables and ip6tables target which delegate the decision on packets to a userspace software.

- iptables -I FORWARD 1 -p tcp --dport 80 -j NFQUEUE --queue-num 0
- iptables -I FORWARD 2 -p tcp --dport 443 -j NFQUEUE --queue-num 0
- iptables -I INPUT 1 -p udp --dport 53 -j NFQUEUE --queue-num 0
- iptables -I INPUT 2 -p udp --sport 53 -j NFQUEUE --queue-num 0

In userspace, urlfilter daemon uses libnetfilter-queue to connect to queue 0 (the default one) and get the messages from kernel.
It then issues a verdict on the packet after checking the  mac address and url.

## Sample UCI configuration
URL filtering daemon requires a configuration file. The configuration file is an uci file `/etc/config/urlfilter`. Sample configuration file is provided below.


````bash
config globals 'globals'
        option enable '1'
        option global_blacklist '1'
        list blacklist_url 'abc.com'
        list blacklist_url 'def.com'
        list blacklist_url 'facebook.com'
        list blacklist_url 'instagram.com'

config profile 'homeoffice'
        list whitelist_url 'facebook.com'
        list whitelist_url 'instagram.com'

config profile 'kids'
        list blacklist_url 'youtube.com'
        list blacklist_url 'game.com'

config filter 'f1'
        option enable '1'
        option profile 'kids'
        list macaddr '00:11:22:33:44:55'
        list macaddr 'AA:BB:CC:33:44:55'
	list day 'Monday'
	list day 'Tuesday'
	list day 'Wednesday'
	list day 'Thursday'
	list day 'Friday'
	option start_time '20:00'
	option duration '64800'

config filter 'f2'
        option enable '1'
        option profile 'homeoffice'
        list macaddr 'CC:DD:EE:33:44:55'
        list macaddr 'EE:AA:BB:11:22:33'
````

