#ifndef _CONFIG_H_
#define _CONFIG_H_

#define MAX_URL_LENGTH 256
#define MAC_ADDR_LEN 32

#define FILTER_ACTIVE 1
#define FILTER_INACTIVE 0

typedef struct profile_info {
	char name[256];
	char **blacklist_url;
	char **whitelist_url;
	unsigned int blacklist_url_cnt;
	unsigned int whitelist_url_cnt;
} profile;

typedef struct filter_info {
	bool enable;
	profile *p; // pointer to profile associated with this filter instance
	char **mac_list;
	unsigned int mac_cnt;
	int day[7];
	char start_time[8];
	unsigned int duration;
} filter;

typedef struct global_info {
	bool enable_filtering;
	bool enable_global_blacklisting;
	char **blacklist_url;
	unsigned int blacklist_url_cnt;
} global;

typedef struct dns_cache {
	char url[1024];
	char **ip_addr;
	char **ipv6_addr;
	char **cname;
	unsigned int ip_addr_cnt;
	unsigned int ipv6_addr_cnt;
	unsigned int cname_cnt;
} dns_cache;

extern dns_cache *global_dns_cache;
extern profile *url_profile;
extern filter *url_filter;
extern global url_global;

extern int profile_cnt;
extern int filter_cnt;
extern int dns_cache_cnt;

// This functions reads the config from the uci file and stores in structures
int read_config(void);
#endif
